unit About;

interface

uses
	Windows, SysUtils, Forms, Classes, Controls, StdCtrls, ExtCtrls;

type
  TAboutBox = class(TForm)
    LblURL: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    ImgExe: TImage;
    LblCopy: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    procedure LblURLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  AboutBox: TAboutBox;

implementation

uses
	iUtils;

{$R *.dfm}

(*  *)
function FmtMem (N: Integer): string;
begin
  if N > 1024 * 1024 then
    Result := Format('%.1fMB', [n / (1024*1024)])
  else
    Result := Format ('%.1fKB', [n / 1024])
end;
//--------------------------------------------
procedure TAboutBox.FormShow(Sender: TObject);
var
    MemInfo : TMemoryStatus;
begin
    MemInfo.dwLength := Sizeof (MemInfo);
    GlobalMemoryStatus (MemInfo);
    Label1.Caption := Format ('RAM :%s(%s)',
        [FmtMem (MemInfo.dwAvailPhys), FmtMem (MemInfo.dwTotalPhys)]);
    Label2.Caption := Format ('SWAP:%s(%s)',
        [FmtMem (MemInfo.dwAvailPageFile), FmtMem (MemInfo.dwTotalPageFile)]);
end;

(* z[y[WWv *)
procedure TAboutBox.LblURLClick(Sender: TObject);
begin
    ExecuteFile(LblURL.Caption);
end;

(* EXEACRǂݍ *)
procedure TAboutBox.FormCreate(Sender: TObject);
begin
	ImgExe.Picture.Icon := Application.Icon;
    LblCopy.Caption := ChangeFileExt(ExtractFileName(Application.ExeName), '');
end;

(* [ESC]I *)
procedure TAboutBox.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
	if (Key = VK_ESCAPE) then
    begin
    	Self.Close;
    end;
end;

end.
 
