unit Main;

interface

uses
	Messages, Forms, Dialogs, Base, StdCtrls, Controls, ExtCtrls, Classes, Graphics,
  ComCtrls;

type
  TMainForm = class(TBaseForm)
    pnlHeader: TPanel;
    imgClose: TImage;
    imgShade: TImage;
    imgMaxMin: TImage;
    imgTitle: TImage;
    imgCaption: TImage;
    pnlBody: TPanel;
    pnlMemo: TPanel;
    pnlFooter: TPanel;
    imgFootLeft: TImage;
    imgResize: TImage;
    pnlFootBody: TPanel;
    imgBottom: TImage;
    lblPage: TLabel;
    imgPage: TImage;
    imgRight: TImage;
    imgLeft: TImage;
    imgAbout: TImage;
    memBody: TMemo;
    procedure imgShadeClick(Sender: TObject);
    procedure imgCloseDblClick(Sender: TObject);
    procedure imgPageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgCaptionMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgResizeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgRightMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgLeftMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgBottomMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgAboutClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    FTempWidth	,
    FTempHeight	: integer;
    CurrentPage: integer;
    procedure	ShowPage();
	procedure	MoveForm();
  public
    { Public 錾 }
	procedure	DroppedAction(); override;
  protected
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
	Windows, Types, SysUtils, About, iMemo;

(*
	=====================================================================
	hbOAhhbv
	=====================================================================
*)
procedure	TMainForm.DroppedAction();
begin
//	ShowMessage('t@ChbvꂽƂ̏B');
end;

(*
	=====================================================================
	tH[TCYp
	=====================================================================
*)

(* 萔l *)
const
	RESIZE_BOTH			= 8;	//(E)
    RESIZE_VERTICAL     = 6;    //(E)
    RESIZE_HORIZONTAL   = 2;    //c()
	RESIZE_REBOTH		= 4;    //()
    RESIZE_REVERTICAL   = 3;    //c()
    RESIZE_REHORIZONTAL = 1;    //()

procedure	TMainForm.MoveForm();
begin
    ReleaseCapture;
    SendMessage(Self.Handle, WM_SYSCOMMAND, SC_MOVE or 2,0);
end;

(* E *)
procedure TMainForm.imgResizeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    if Button = mbLeft then
    begin
//        ReleaseCapture;
//        SendMessage(Self.Handle, WM_SYSCOMMAND, SC_SIZE or RESIZE_BOTH, 0);
		MoveForm();
    end;
end;

(* E *)
procedure TMainForm.imgRightMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    if Button = mbLeft then
    begin
//        ReleaseCapture;
//        SendMessage(Self.Handle, WM_SYSCOMMAND, SC_SIZE or RESIZE_HORIZONTAL, 0);
		MoveForm();
    end;
end;

(*  *)
procedure TMainForm.imgLeftMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button = mbLeft then
    begin
//        ReleaseCapture;
//        SendMessage(Self.Handle, WM_SYSCOMMAND, SC_SIZE or RESIZE_REHORIZONTAL, 0);
		MoveForm();
    end;
end;

(*  *)
procedure TMainForm.imgBottomMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button = mbLeft then
    begin
//        ReleaseCapture;
//        SendMessage(Self.Handle, WM_SYSCOMMAND, SC_SIZE or RESIZE_VERTICAL, 0);
		MoveForm();
    end;
end;

(*
	=====================================================================
	^LvVo[
	=====================================================================
*)

(* ړ *)
procedure TMainForm.imgCaptionMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    if Button = mbLeft then
    begin
//        ReleaseCapture;
//        SendMessage(Self.Handle, WM_SYSCOMMAND, SC_MOVE or 2,0);
		MoveForm();
    end;
end;

(* EBhEVF[h *)
procedure TMainForm.imgShadeClick(Sender: TObject);
begin
	if Self.Height = imgCaption.Height then
		Self.Height := 300
    else
		Self.Height := imgCaption.Height;
end;

(* I *)
procedure TMainForm.imgCloseDblClick(Sender: TObject);
begin
	Self.Close;
end;

(*
	=====================================================================
	̑
	=====================================================================
*)

(* AboutBox *)
procedure TMainForm.imgAboutClick(Sender: TObject);
begin
	AboutBox.ShowModal();
end;

(*
	=====================================================================
	CҏWp
	=====================================================================
*)

(*  *)
procedure TMainForm.FormShow(Sender: TObject);
begin
	inherited;
	FTempWidth	:= Self.Width;
    FTempHeight	:= Self.Height;
	MemoList := TMemoList.Create(memBody.Lines);
    CurrentPage := 0;
	ShowPage();
end;

(* y[W؂ւ *)
procedure TMainForm.imgPageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	if X > 10 then Inc(CurrentPage) else Dec(CurrentPage);
    ShowPage();
end;

(* y[W؂ւ *)
procedure	TMainForm.ShowPage();
begin
    lblPage.Caption := Format('- %d -', [MemoList.ChangePage(CurrentPage) + 1]);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
	inherited;
    MemoList.Free;
end;

(* UV[gJbg *)
procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	inherited;
	if (ssCtrl in Shift) then
    begin
		case Key of
			Ord('A'): begin memBody.SelectAll; end;
			Ord('P'): begin Dec(CurrentPage); ShowPage(); end;
			Ord('N'): begin Inc(CurrentPage); ShowPage();end;
        end;
    end;
end;

end.
