unit iMemo;

interface

uses
	Classes;

type
	TMemoList = class
    private
    	FList		: TList;
		FEditor		: TStrings;
        FWork       : TStrings;
		FActivePage	: integer;
		FFileName	: string;
		procedure	AddPage(AText: string);
        procedure	SaveAll;
        procedure	LoadAll;
		procedure	SavePage;
		procedure	LoadPage;
    public
		constructor	Create(AEditor: TStrings);
        destructor	Destroy; override;
		function	ChangePage(AIndex: integer): integer;
    end;

var
	MemoList: TMemoList;

implementation

uses
	SysUtils, Forms;

(* y[W̒ǉ *)
procedure	TMemoList.AddPage(AText: string);
var
	SL: TStrings;
begin
	SL := TStringList.Create;
    SL.Text := AText;
	FList.Add(SL);
end;

(* eLXgۑ *)
procedure	TMemoList.SavePage;
begin
	TStringList(FList.Items[FActivePage]).Assign(FEditor);
end;

(* eLXg\ *)
procedure	TMemoList.LoadPage;
begin
	FEditor.Assign(TStringList(FList.Items[FActivePage]));
end;

(* RXgN^ *)
constructor	TMemoList.Create(AEditor: TStrings);
begin
    FFileName := ChangeFileExt(Application.ExeName, '.dat');
	FList := TList.Create;
	FActivePage := 0;
    FEditor := AEditor;
	FWork := TStringList.Create;
	LoadAll;
    LoadPage;
end;

(* fXgN^ *)
destructor	TMemoList.Destroy;
begin
    SavePage;
	SaveAll;
    while FList.Count > 0 do
    begin
		TStringList(FList.Items[0]).Free;
        FList.Delete(0);
    end;
    FWork.Free;
    FList.Free;
end;

(* \y[WύX *)
function	TMemoList.ChangePage(AIndex: integer): integer;
begin
    SavePage;
	if AIndex < 0 then
    begin
    	FActivePage := 0;
    end
    else
    if AIndex >= FList.Count then
    begin
    	FActivePage := FList.Count;
        AddPage('');
    end
    else
    begin
    	FActivePage := AIndex;
    end;
    LoadPage;
	Result := FActivePage;
end;

(* t@Cɕۑ *)
procedure	TMemoList.SaveAll;
var
	i: integer;
    Temp: TStringList;
begin
	FWork.Clear;
	for i := 0 to FList.Count - 1 do
    begin
	    Temp := TStringList(FList[i]);
		FWork.AddStrings(Temp);
		FWork.Add(#1);
    end;
    FWork.SaveToFile(FFileName);
end;

(* t@Cǂݍ *)
procedure	TMemoList.LoadAll;
var
	Text: string;
begin
	if FileExists(FFileName) then
    begin
		FWork.LoadFromFile(FFileName);
		//y[W̓ǂݎ
        Text := '';
		if FWork.Count = 0 then AddPage('');
		while FWork.Count > 0 do
        begin
			if FWork[0] <> #1 then
            begin
            	Text := Text + FWork[0] + #13#10; 
            end
            else
            begin
				AddPage(Text);
                Text := '';
            end;
            FWork.Delete(0);
        end;
    end
    else
    begin
		AddPage('');
    end;
end;

end.
